﻿/*
 * 作成日： 2004/08/05
 *
 * TODO この生成されたファイルのテンプレートを変更するには次を参照。
 * ウィンドウ ＞ 設定 ＞ Java ＞ コード・スタイル ＞ コード・テンプレート
 */
package dictionary;

import java.util.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.beans.*;
import java.io.*;

/**
 * @author Administrator
 *
 * TODO この生成された型コメントのテンプレートを変更するには次を参照。
 * ウィンドウ ＞ 設定 ＞ Java ＞ コード・スタイル ＞ コード・テンプレート
 */
public class Dictionary extends JFrame implements ActionListener, ListSelectionListener{

    private Collection words; // 単語集

    private JPanel panel; // メインパネル
    private JTextField jpWordText, enWordText; // 単語(日)、単語(英)
    private JTextArea notesText; // 内容
    private JButton submitButton, delButton, clearButton; // 登録ボタン, 削除ボタン, クリアボタン
    private JList wordList;
    private String dicFile = "dic.xml"; // wordListの中の選択した文字
    
    public Dictionary(){
        fread();
        this.gui_init();
    }
    
    /*
     * GUI設定
     */
    private void gui_init(){
        this.setTitle("単語帳");
        this.setBounds(10,10,600,400);
        
        this.panel = new JPanel();

        Box b1, b2;
        b1 = Box.createVerticalBox();
        b2 = Box.createVerticalBox();
        JPanel p1, p2, p3, p4, p5, p6, p7;
        b1.add(p1 = new JPanel());
        b1.add(p2 = new JPanel());
        b1.add(p3 = new JPanel());
        b1.add(p4 = new JPanel());
        b2.add(p5 = new JPanel());
        b2.add(p6 = new JPanel());
        b2.add(p7 = new JPanel());
        
        
        panel.setLayout(new FlowLayout(FlowLayout.LEFT));
        panel.add(b1);
        panel.add(b2);
        
        /* 左側のパーツ */
        p1.add(new JLabel("単語(日)"));
        p1.add(this.jpWordText = new JTextField(15));
        p1.setLayout(new FlowLayout(FlowLayout.LEFT));
        p2.add(new JLabel("単語(英)"));
        p2.add(this.enWordText = new JTextField(15));
        p2.setLayout(new FlowLayout(FlowLayout.LEFT));
        JLabel notesLabel;
        p3.add(notesLabel = new JLabel("説明"));
        p3.add(this.notesText = new JTextArea(13,30));

        p4.add(this.clearButton = new JButton("新規単語"));
        clearButton.setActionCommand("Clear");
        this.clearButton.addActionListener(this);
        
        p4.add(this.submitButton = new JButton("登録"));
        submitButton.setActionCommand("AddWord");
        this.submitButton.addActionListener(this);
        
        /* 右側のパーツ */
        p5.add(new JLabel("単語リスト"));
        JScrollPane wordListScr = new JScrollPane();
        p6.add(wordListScr);
        p7.add(this.delButton = new JButton("削除"));
        delButton.setActionCommand("DelWord");
        this.delButton.addActionListener(this);

        wordListScr.getViewport().setView( this.wordList = new JList() ); // スクロールバーに入れる
        wordList.addListSelectionListener(this); // リスト選択リスナー登録
        wordList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION); // 一つしか選択出来ない
        wordListScr.setPreferredSize(new Dimension(200, 280));
        syncWordListData(words); // 同期
        
        this.getContentPane().add(panel);

        
        this.addWindowListener(new WindowAdapter(){
			public void windowClosing(WindowEvent e){System.exit(0);}
		});
        
        this.setVisible(true);
    }
    
    /*
     * ListSelectionEvent
     * @see javax.swing.event.ListSelectionListener#valueChanged(javax.swing.event.ListSelectionEvent)
     */
    public void valueChanged(ListSelectionEvent e){
        String sel = (String)this.wordList.getSelectedValue(); // 選択した文字
        Iterator i = this.words.iterator();
        Word w;
        while(i.hasNext()){
            w = (Word)i.next();
            if( w.toString().equals(sel)){
                this.jpWordText.setText(w.getJpName());
                this.enWordText.setText(w.getEnName());
                this.notesText.setText(w.getNotes());
                break;
            }
        }
    }
    
    /*
     * ActionEvent
     * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
     */
    public void actionPerformed(ActionEvent ae){
        String action = ae.getActionCommand();
        //登録ボタンが押された時の処理
        if (action.equals("AddWord")) {
            if (!(jpWordText.getText().equals("") && enWordText.getText().equals(""))) {
                addWord(jpWordText.getText(), enWordText.getText(), notesText.getText());

                printWord();

                jpWordText.setText(""); // 初期化
                enWordText.setText("");
                notesText.setText("");

                syncWordListData(words); // 同期
                fout(); // ファイル保存
            }
        }
        
        //削除ボタンが押された時の処理
        if(action.equals("DelWord")){
            String sel = (String)this.wordList.getSelectedValue(); // 選択された単語名
            Iterator i = this.words.iterator();
            Word w;
            while(i.hasNext()){
                w = (Word)i.next();
                if( w.toString().equals(sel) ){
                    this.words.remove(w);
                    break;
                }
            }
            syncWordListData(words); // 同期
            fout(); // ファイル保存
        }
        
        //クリアボタンが押された時の処理
        if(action.equals("Clear")){
            this.jpWordText.setText("");
            this.enWordText.setText("");
            this.notesText.setText("");
        }
      }
    
    /*
     * wordsの状態をファイル出力
     */
    public void fout(){

        try{
            XMLEncoder xout = new XMLEncoder(new BufferedOutputStream(new FileOutputStream(this.dicFile)));
            xout.writeObject(this.words);
            xout.close();
        }
        catch (Exception e) {
    	    System.out.println("Exception : " + e);
    	}
        finally{
            System.out.println("辞書ファイル(XML)出力完了");
        }
    }
    
    /*
     * ファイルを読み、wordsの状態を復元
     */
    public void fread() {
        try{
        XMLDecoder d = new XMLDecoder(new BufferedInputStream(new FileInputStream(this.dicFile)));
        this.words = (Collection)d.readObject();
        }
        catch (Exception e) {
    	    System.out.println("Exception : " + e);
    	}
        finally{
            System.out.println("辞書ファイル(XML)入力完了");
        }
        
    }
    
    /*
     * GUIの単語リストと、データを同期させる
     */
    public void syncWordListData(Collection c){
        Iterator i =  c.iterator();
        Vector v = new Vector();
        while(i.hasNext()){
            v.add( ((Word)i.next()).toString());
        }
        this.wordList.setListData(v);
    }
    
    /*
     * 単語を追加する
     */
    public void addWord(String jpName, String enName, String notes){
        Word word = new Word();
        word.setJpName(jpName);
        word.setEnName(enName);
        word.setNotes(notes);
        this.words.add(word);
    }
    
    public void printWord(){
        Iterator i = this.words.iterator();
        System.out.println("***登録された単語***");
        while(i.hasNext()){
            Word w = (Word)i.next();
            System.out.println( w.getJpName());
        }
        System.out.println(this.wordList.size());
    }
    
    
    
    
    public static void main(String [] args){
        Dictionary app = new Dictionary();
    }
    
}
